package com.book.push.service.dao.impl;

import com.book.dao.cps.mapper.UserMapper;
import com.book.dao.cps.pojo.AdminConfig;
import com.book.dao.cps.pojo.User;
import com.book.push.service.dao.AdminConfigService;
import com.book.push.service.dao.UserService;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.checkerframework.checker.units.qual.A;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * created in 2021/8/17
 * Project: book-store
 *
 * @author win7
 */
@Service
public class UserServiceImpl implements UserService {
    @Autowired
    private UserMapper userMapper;
    @Autowired
    private AdminConfigService adminConfigService;

    @Override
    public User selectUserByUser(User user) {
        return userMapper.selectByUser(user);
    }

    @Override
    public User selectByOpenId(String openId) {
        return userMapper.selectByOpenId(openId);
    }

    @Override
    public User selectById(Long id) {
        return userMapper.selectByPrimaryKey(id);
    }

    @Override
    public User createUserByWxUser(WxMpUser wxMpUser, int channel_id) {

        User user = new User();
        user.setOpenid(wxMpUser.getOpenId());
        user.setArea(wxMpUser.getCity());
        user.setCity(wxMpUser.getCity());
        user.setCountry(wxMpUser.getCountry());
        user.setUnionid(wxMpUser.getUnionId());
        user.setNickname(wxMpUser.getNickname());
        user.setSex(wxMpUser.getSex());
//        user.setMobile(wxMpUser.getmobile);
        user.setAvatar(wxMpUser.getHeadImgUrl());
        user.setSubscribeTime(Integer.valueOf(String.valueOf(System.currentTimeMillis() / 1000)));
        user.setOperateTime(user.getSubscribeTime());
//        user.setRegisterIp(wxMpUser.geti);
        user.setProvince(wxMpUser.getProvince());
        user.setCreatetime(Integer.valueOf(String.valueOf(System.currentTimeMillis() / 1000)));
        user.setChannelId(channel_id);

        userMapper.insert(user);
        return user;
    }

    @Override
    public AdminConfig selectAdminConfigByOpenid(String openid) {
        User user = userMapper.selectByOpenId(openid);
        Integer channelId = user.getChannelId();
        AdminConfig adminConfig = adminConfigService.selectByAdminId(channelId);
        return adminConfig;
    }

    @Override
    public List<User> selectListByPushMap(Map map) {

        return userMapper.selectListByPushMap(map);
    }
}
